const H = [
  "left_control",
  "left_shift",
  "left_option",
  "left_command",
  "right_control",
  "right_shift",
  "right_option",
  "right_command",
  "fn"
], re = [
  ...H,
  "caps_lock"
], se = [
  "return_or_enter",
  "escape",
  "delete_or_backspace",
  "delete_forward",
  "tab",
  "spacebar",
  "hyphen",
  "equal_sign",
  "open_bracket",
  "close_bracket",
  "backslash",
  "non_us_pound",
  "semicolon",
  "quote",
  "grave_accent_and_tilde",
  "comma",
  "period",
  "slash",
  "non_us_backslash"
], ae = [
  "up_arrow",
  "down_arrow",
  "left_arrow",
  "right_arrow",
  "page_up",
  "page_down",
  "home",
  "end"
], le = [
  "a",
  "b",
  "c",
  "d",
  "e",
  "f",
  "g",
  "h",
  "i",
  "j",
  "k",
  "l",
  "m",
  "n",
  "o",
  "p",
  "q",
  "r",
  "s",
  "t",
  "u",
  "v",
  "w",
  "x",
  "y",
  "z"
], ue = [
  "1",
  "2",
  "3",
  "4",
  "5",
  "6",
  "7",
  "8",
  "9",
  "0"
], ce = [
  "f1",
  "f2",
  "f3",
  "f4",
  "f5",
  "f6",
  "f7",
  "f8",
  "f9",
  "f10",
  "f11",
  "f12",
  "f13",
  "f14",
  "f15",
  "f16",
  "f17",
  "f18",
  "f19",
  "f20"
], de = [
  "keypad_num_lock",
  "keypad_slash",
  "keypad_asterisk",
  "keypad_hyphen",
  "keypad_plus",
  "keypad_enter",
  "keypad_1",
  "keypad_2",
  "keypad_3",
  "keypad_4",
  "keypad_5",
  "keypad_6",
  "keypad_7",
  "keypad_8",
  "keypad_9",
  "keypad_0",
  "keypad_period",
  "keypad_equal_sign",
  "keypad_comma"
], fe = [
  "print_screen",
  "scroll_lock",
  "pause",
  "insert",
  "application",
  "help",
  "power"
], he = [
  "international1",
  "international3",
  "lang1",
  "lang2"
], pe = ["japanese_eisuu", "japanese_kana"], _e = [
  "volume_down",
  // equal to `volume_decrement`
  "volume_up",
  // equal to `volume_increment`
  "mute",
  "volume_decrement",
  "volume_increment"
], B = [
  // Function keys
  "f21",
  "f22",
  "f23",
  "f24",
  // Keys in pc keyboards
  "execute",
  "menu",
  "select",
  "stop",
  "again",
  "undo",
  "cut",
  "copy",
  "paste",
  "find",
  // International keys
  "international2",
  "international4",
  "international5",
  "international6",
  "international7",
  "international8",
  "international9",
  "lang3",
  "lang4",
  "lang5",
  "lang6",
  "lang7",
  "lang8",
  "lang9",
  // Japanese
  "japanese_pc_nfer",
  // PCキーボードの無変換キー
  "japanese_pc_xfer",
  // PCキーボードの変換キー
  "japanese_pc_katakana",
  // PCキーボードのかなキー
  // Others
  "keypad_equal_sign_as400",
  "locking_caps_lock",
  "locking_num_lock",
  "locking_scroll_lock",
  "alternate_erase",
  "sys_req_or_attention",
  "cancel",
  "clear",
  "prior",
  "return",
  // rarely used return (HID usage 0x9e)
  "separator",
  "out",
  "oper",
  "clear_or_again",
  "cr_sel_or_props",
  "ex_sel"
], P = [
  // Disable this key
  "vk_none",
  // Others
  "vk_consumer_brightness_down",
  // equal to `display_brightness_decrement`
  "vk_consumer_brightness_up",
  // equal to `display_brightness_increment`
  "vk_mission_control",
  // equal to `mission_control`
  "vk_launchpad",
  // equal to `launchpad`
  "vk_dashboard",
  // equal to `dashboard`
  "vk_consumer_illumination_down",
  // equal to `illumination_decrement`
  "vk_consumer_illumination_up",
  // equal to `illumination_increment`
  "vk_consumer_previous",
  // equal to `rewind`
  "vk_consumer_play",
  // equal to `play`
  "vk_consumer_next",
  // equal to `fast_forward`
  "display_brightness_decrement",
  "display_brightness_increment",
  "rewind",
  "play_or_pause",
  "fastforward",
  "apple_display_brightness_decrement",
  "apple_display_brightness_increment",
  "dashboard",
  "launchpad",
  "mission_control",
  "apple_top_case_display_brightness_decrement",
  "apple_top_case_display_brightness_increment",
  "illumination_decrement",
  "illumination_increment"
], j = {
  "⌘": "command",
  "⌥": "option",
  "⌃": "control",
  "⇧": "shift",
  "⇪": "caps_lock"
}, ee = {
  "↑": "up_arrow",
  "↓": "down_arrow",
  "←": "left_arrow",
  "→": "right_arrow",
  "⇞": "page_up",
  "⇟": "page_down",
  "↖︎": "home",
  "↘︎": "end"
}, te = {
  "⏎": "return_or_enter",
  "⎋": "escape",
  "⌫": "delete_or_backspace",
  "⌦": "delete_forward",
  "⇥": "tab",
  "␣": "spacebar",
  "-": "hyphen",
  "=": "equal_sign",
  "[": "open_bracket",
  "]": "close_bracket",
  "\\": "backslash",
  ";": "semicolon",
  "'": "quote",
  "`": "grave_accent_and_tilde",
  ",": "comma",
  ".": "period",
  "/": "slash"
}, z = {
  ...ee,
  ...te,
  "⇪": j["⇪"]
}, me = [
  ...H,
  ...re,
  ...se,
  ...ae,
  ...le,
  ...ue,
  ...ce,
  ...de,
  ...fe,
  ...he,
  ...pe,
  ..._e,
  ...B,
  ...P
];
function v(t, e, i) {
  if (typeof t == "number")
    return `${t}`;
  if (t.length > 1 && q(t)) {
    const n = x(t);
    if ((n == null ? void 0 : n.length) === 1)
      return n[0];
    throw new Error(`Invalid key ${t}`);
  }
  if (t in z)
    return z[t];
  const o = t;
  if (!me.includes(o))
    throw new Error(`${o} is not valid key_code`);
  if (e != null && e.includes(o))
    throw new Error(`Key ${t} cannot be used ${i || "here"}`);
  return o;
}
const ye = {
  Meh: ["option", "control", "shift"],
  Hyper: ["command", "option", "control", "shift"],
  SuperHyper: ["command", "option", "control", "shift", "fn"]
}, G = {
  "⌘⇧": ["command", "shift"],
  "⌥⇧": ["option", "shift"],
  "⌃⇧": ["control", "shift"],
  "⌘⌥": ["command", "option"],
  "⌘⌃": ["command", "control"],
  "⌥⌃": ["option", "control"],
  "⌘⌥⌃": ["command", "option", "control"],
  "⌘⌥⇧": ["command", "option", "shift"],
  "⌘⌃⇧": ["command", "control", "shift"],
  "⌥⌃⇧": ["option", "control", "shift"],
  "⌘⌥⌃⇧": ["command", "option", "control", "shift"],
  ...ye
};
function C(t) {
  if (!t)
    return;
  if (typeof t == "string")
    return q(t) ? x(t) : t in j ? [j[t]] : t in G ? G[t] : [t];
  if (Array.isArray(t))
    return ge(t) ? ke(t) : t.map(we);
  let e;
  "left" in t ? e = T("left", t.left) : "l" in t && (e = T("left", t.l));
  let i;
  if ("right" in t ? i = T("right", t.right) : "r" in t && (i = T("right", t.r)), !(!(e != null && e.length) && !(i != null && i.length)))
    return [...e || [], ...i || []];
}
const ie = /^(left|l|<|‹)([⌘⌥⌃⇧]*)$/, oe = /^(right|r|>|›)([⌘⌥⌃⇧]*)$/;
function $(t, e) {
  if (!(!t && !e))
    return {
      mandatory: Q(t),
      optional: Q(e)
    };
}
function Q(t) {
  if (t)
    return t === "any" ? ["any"] : C(t);
}
const be = /* @__PURE__ */ new Set([
  "command",
  "option",
  "control",
  "shift"
]);
function q(t) {
  return ie.test(t) || oe.test(t);
}
function x(t) {
  const e = t.match(ie);
  if (e)
    return T("left", e[2]);
  const i = t.match(oe);
  if (i)
    return T("right", i[2]);
}
function ge(t) {
  return t.some(q);
}
function ke(t) {
  return t.reduce(
    (e, i) => [
      ...e,
      ...q(i) ? x(i) || [] : C(i) || []
    ],
    []
  );
}
function T(t, e) {
  var i;
  if (e)
    return (i = C(e)) == null ? void 0 : i.map(
      (o) => be.has(o) ? `${t}_${o}` : o
    );
}
function we(t) {
  return t in j ? j[t] : t;
}
function h(t, e, i) {
  const o = v(
    t,
    B,
    "as to.key_code"
  );
  return {
    ...i,
    key_code: o,
    modifiers: e ? C(e) : void 0
  };
}
function ve(t) {
  return h("left_command", "⌥⌃⇧", t);
}
function Ce(t) {
  return h("left_option", "⌃⇧", t);
}
function Me(t) {
  return h("fn", "⌘⌥⌃⇧", t);
}
function Ee(t) {
  return h("vk_none", void 0, t);
}
function Te(t, e, i) {
  return {
    ...i,
    consumer_key_code: t,
    modifiers: e ? C(e) : void 0
  };
}
function Ke(t, e, i) {
  return {
    ...i,
    pointing_button: t,
    modifiers: e ? C(e) : void 0
  };
}
function U(t) {
  return { shell_command: t };
}
function Ae(t) {
  const e = t.match(/^"?(.*?)(.app)?"?$/);
  return U(`open -a "${(e == null ? void 0 : e[1]) || t}".app`);
}
function Se(t) {
  return U(`osascript -e '
set prev to the clipboard
set the clipboard to "${t}"
tell application "System Events"
  keystroke "v" using command down
  delay 0.1
end tell
set the clipboard to prev'`);
}
function $e(t) {
  return { select_input_source: t };
}
function p(t, e = 1) {
  return { set_variable: { name: t, value: e } };
}
function je(t, e) {
  return { set_notification_message: { id: t, text: e } };
}
function Oe(t) {
  return { set_notification_message: { id: t, text: "" } };
}
function Pe(t) {
  return { mouse_key: t };
}
function Ve(t, e = "toggle") {
  return { sticky_modifier: { [t]: e } };
}
function Le(t) {
  return {
    software_function: { cg_event_double_click: { button: t } }
  };
}
function De(t) {
  return { software_function: { set_mouse_cursor_position: t } };
}
function Be(t) {
  return {
    software_function: {
      iokit_power_management_sleep_system: { delay_milliseconds: t }
    }
  };
}
function b(t) {
  return Array.isArray(t) ? t : [t];
}
function O(t, e = 1, i) {
  return new g({ type: "variable_if", name: t, value: e, description: i });
}
function ct(t, e) {
  let i;
  if (Array.isArray(t))
    i = t.map(R);
  else if (typeof t == "string" || t instanceof RegExp)
    i = [R(t)];
  else
    return new g({
      type: "frontmost_application_if",
      description: e,
      file_paths: t.file_paths.map(R)
    });
  return new g({
    type: "frontmost_application_if",
    description: e,
    bundle_identifiers: i
  });
}
function dt(t, e) {
  return new g({
    type: "device_if",
    identifiers: b(t),
    description: e
  });
}
function ft(t, e) {
  return new g({
    type: "device_exists_if",
    identifiers: b(t),
    description: e
  });
}
function ht(t, e) {
  return new g({
    type: "keyboard_type_if",
    keyboard_types: b(t),
    description: e
  });
}
function pt(t, e) {
  return new g({
    type: "input_source_if",
    input_sources: b(t),
    description: e
  });
}
function _t(t = !0, e) {
  return new g({ type: "event_changed_if", value: t, description: e });
}
const qe = Re({
  frontmost_application_if: "frontmost_application_unless",
  device_if: "device_unless",
  device_exists_if: "device_exists_unless",
  keyboard_type_if: "keyboard_type_unless",
  input_source_if: "input_source_unless",
  variable_if: "variable_unless",
  event_changed_if: "event_changed_unless"
});
class g {
  constructor(e) {
    this.condition = e;
  }
  /** Switch type {condition}_if to {condition}_unless, and vice versa */
  unless() {
    return new g({
      ...this.condition,
      type: qe[this.condition.type]
    });
  }
  build() {
    return { ...this.condition };
  }
}
function Ne(t) {
  return typeof t.build == "function";
}
function M(t) {
  return Ne(t) ? t.build() : t;
}
function R(t) {
  return typeof t == "string" ? t : t.toString().slice(1, -1);
}
function Re(t) {
  return Object.keys(t).reduce((e, i) => ({ ...e, [e[i]]: i }), t);
}
const K = {};
for (let t = 0; t <= 9; t++)
  K[t] = h(t);
const Ie = "abcdefghijklmnopqrstuvwxyz".split("");
for (const t of Ie)
  K[t] = h(t), K[t.toUpperCase()] = h(t, "⇧");
const Fe = [
  ...Object.keys(ee),
  ...Object.keys(te)
];
for (const t of Fe)
  K[t] = h(t);
const He = {
  1: "!",
  2: "@",
  3: "#",
  4: "$",
  5: "%",
  6: "^",
  7: "&",
  8: "*",
  9: "(",
  0: ")",
  "'": '"',
  "=": "+",
  ";": ":",
  ",": "<",
  ".": ">",
  "/": "?",
  "-": "_",
  "[": "{",
  "\\": "|",
  "]": "}",
  "`": "~"
};
for (const [t, e] of Object.entries(He))
  K[e] = h(t, "⇧");
function xe(t, e) {
  return t.split("").map((i) => {
    const o = (e == null ? void 0 : e[i]) || K[i];
    if (!o)
      throw new Error(
        `${i} is unknown. Please provide a map with { ${i}: {ToEvent} }`
      );
    return o;
  });
}
const Ue = ["optionalAny", "?any", "??"];
function Je(t) {
  return !t || typeof t != "string" ? !1 : Ue.includes(t);
}
function We(t) {
  return /^\?(left|l|<|‹|right|r|>|›)?([⌘⌥⌃⇧⇪]*)$/.test(t);
}
function m(t, e) {
  if (!t)
    return $(t, e);
  if (Je(t))
    return $("", "any");
  if (typeof t == "string") {
    if (We(t))
      return $(
        "",
        C(t.slice(1))
      );
    if (t.startsWith("?"))
      throw new Error(`${t} is not valid optional alias`);
  }
  return typeof t == "object" && "optional" in t ? $("", t.optional) : $(t, e);
}
function J(t, e, i) {
  if (typeof t == "object")
    return new A(t);
  const o = v(
    t,
    P,
    "for from.key_code"
  );
  return new A({
    key_code: o,
    modifiers: m(e, i)
  });
}
function mt(t, e, i) {
  return new A({
    consumer_key_code: t,
    modifiers: m(e, i)
  });
}
function yt(t, e, i) {
  return new A({
    pointing_button: t,
    modifiers: m(e, i)
  });
}
class A {
  constructor(e) {
    this.manipulator = { type: "basic", from: e };
  }
  /** The FromEvent of the Manipulator. */
  get from() {
    return this.manipulator.from;
  }
  to(e, i, o) {
    return this.addToEvent(
      typeof e == "object" ? e : h(e, i, o)
    ), this;
  }
  /** To Hyper key ⌘⌥⌃⇧ */
  toHyper(e) {
    return this.addToEvent(ve(e)), this;
  }
  /** To Meh key ⌥⌃⇧ */
  toMeh(e) {
    return this.addToEvent(Ce(e)), this;
  }
  /** To SuperHyper key ⌘⌥⌃⇧fn */
  toSuperHyper(e) {
    return this.addToEvent(Me(e)), this;
  }
  /** To vk_none (Disable this key) */
  toNone(e) {
    return this.addToEvent(Ee(e)), this;
  }
  /** To { consumer_key_code } */
  toConsumerKey(e, i, o) {
    return this.addToEvent(Te(e, i, o)), this;
  }
  /** Map to mouse button */
  toPointingButton(e, i, o) {
    return this.addToEvent(Ke(e, i, o)), this;
  }
  /** Map to shell command */
  to$(e) {
    return this.addToEvent(U(e)), this;
  }
  /** Map to `$ open -a {app}.app` */
  toApp(e) {
    return this.addToEvent(Ae(e)), this;
  }
  /** Map to paste {text} via clipboard */
  toPaste(e) {
    return this.addToEvent(Se(e)), this;
  }
  /** To change the current input source */
  toInputSource(e) {
    return this.addToEvent($e(e)), this;
  }
  /** Map to setting a variable */
  toVar(e, i = 1) {
    return this.addToEvent(p(e, i)), this;
  }
  /** To set or remove (set text to '') the notification message */
  toNotificationMessage(e, i) {
    return this.addToEvent(je(e, i)), this;
  }
  /** To remove the notification message */
  toRemoveNotificationMessage(e) {
    return this.addToEvent(Oe(e)), this;
  }
  /** Move mouse cursor by delta */
  toMouseKey(e) {
    return this.addToEvent(Pe(e)), this;
  }
  /** Changes to a sticky modifier key */
  toStickyModifier(e, i = "toggle") {
    return this.addToEvent(Ve(e, i)), this;
  }
  /** @see https://karabiner-elements.pqrs.org/docs/json/complex-modifications-manipulator-definition/to/software_function/cg_event_double_click/ */
  toCgEventDoubleClick(e) {
    return this.addToEvent(Le(e)), this;
  }
  /** Set mouse cursor position */
  toMouseCursorPosition(e) {
    return this.addToEvent(De(e)), this;
  }
  /** To causes a system sleep */
  toSleepSystem(e) {
    return this.addToEvent(Be(e)), this;
  }
  /** To type a string of keys */
  toTypeSequence(e, i) {
    return this.addToEvent(xe(e, i)), this;
  }
  toIfAlone(e, i, o) {
    return this.pushOrCreateList(
      this.manipulator,
      "to_if_alone",
      typeof e == "object" ? e : h(e, i, o)
    ), this;
  }
  toIfHeldDown(e, i, o) {
    return this.pushOrCreateList(
      this.manipulator,
      "to_if_held_down",
      typeof e == "object" ? e : h(e, i, o)
    ), this;
  }
  toAfterKeyUp(e, i, o) {
    return this.pushOrCreateList(
      this.manipulator,
      "to_after_key_up",
      typeof e == "object" ? e : h(e, i, o)
    ), this;
  }
  toDelayedAction(e, i) {
    const o = this.manipulator.to_delayed_action || {
      to_if_invoked: [],
      to_if_canceled: []
    };
    return b(e).forEach((n) => o.to_if_invoked.push(n)), b(i).forEach((n) => o.to_if_canceled.push(n)), this.manipulator.to_delayed_action = o, this;
  }
  description(e) {
    return this.manipulator.description = e, this;
  }
  condition(...e) {
    const { conditions: i = [] } = this.manipulator;
    return this.manipulator.conditions = [...i, ...e.map(M)], this;
  }
  parameters(e) {
    return this.manipulator.parameters = { ...this.manipulator.parameters, ...e }, this;
  }
  build(e) {
    return [{ ...this.manipulator }];
  }
  addToEvent(e) {
    this.pushOrCreateList(this.manipulator, "to", e);
  }
  pushOrCreateList(e, i, o) {
    const n = e[i] || [];
    b(o).forEach((r) => n.push(r)), Object.assign(e, { [i]: n });
  }
}
function ze(t) {
  return typeof t.build == "function";
}
function S(t, e) {
  return ze(t) ? t.build(e) : "type" in t ? [t] : Object.entries(t).reduce(
    (o, [n, r]) => [...o, ...J(n).to(r).build(e)],
    []
  );
}
function bt(...t) {
  return (e) => {
    const i = t.map(M);
    function o(s) {
      return s.type !== "basic" ? s : {
        ...s,
        conditions: [...s.conditions || [], ...i]
      };
    }
    const r = (Array.isArray(e) ? e : S(e)).reduce(
      (s, u) => [...s, ...S(u).map(o)],
      []
    );
    return Object.assign(r, { build: () => r });
  };
}
function gt(t) {
  return (e) => ({
    build: () => (Array.isArray(t) ? t.map((o, n) => [o, n]) : Object.entries(t)).reduce(
      (o, [n, r]) => [...o, ...S(e(n, r))],
      []
    )
  });
}
function kt(t, e) {
  return (i) => ({
    build: (o) => {
      const n = m(
        t,
        e
      );
      return (Array.isArray(i) ? i : S(i)).map((s) => S(s, o)).reduce((s, u) => s.concat(u), []).map((s) => {
        var a;
        const u = Object.keys(n).reduce(
          (d, c) => {
            var l;
            if (!((l = n[c]) != null && l.length))
              return d;
            const f = /* @__PURE__ */ new Set([
              ...d[c] || [],
              ...n[c]
            ]);
            return d[c] = f.has("any") ? ["any"] : Array.from(f), d;
          },
          { ...(a = s.from) == null ? void 0 : a.modifiers }
        );
        return s.from = { ...s.from, modifiers: u }, s;
      });
    }
  });
}
function Ge(t, e, i) {
  const o = (r) => v(r, P, "for from.simultaneous"), n = new Qe({
    simultaneous: t.map(
      (r) => typeof r == "object" ? r : { key_code: o(r) }
    ),
    simultaneous_options: e
  });
  return i && n.parameters({
    "basic.simultaneous_threshold_milliseconds": i
  }), n;
}
class Qe extends A {
  constructor(e) {
    super(e);
  }
  modifiers(e, i) {
    return this.manipulator.from.modifiers = e || i ? m(e, i) : void 0, this;
  }
}
const X = {
  "double_tap.delay_milliseconds": 200
};
function wt(t, e, i, o) {
  const n = v(
    t,
    [...B, ...P],
    "for double tap"
  ), r = new Xe({ key_code: n });
  return o ? (r.delay(o), r.from.modifiers = m(
    e,
    i
  )) : i ? typeof i == "number" ? (r.delay(i), r.from.modifiers = m(
    e
  )) : r.from.modifiers = m(
    e,
    i
  ) : e && (typeof e == "number" ? r.delay(e) : r.from.modifiers = m(
    e
  )), r;
}
class Xe extends A {
  constructor(e) {
    super(e), this.singleTapEvent = void 0;
  }
  /** Set single tap which is from key by default; null to disable */
  singleTap(e) {
    return this.singleTapEvent = e, this;
  }
  /** Set the delay parameter */
  delay(e) {
    return this.delayParam = e, this;
  }
  build(e) {
    var f;
    const i = (e == null ? void 0 : e.getParameters(X)) ?? X, o = this.delayParam || i["double_tap.delay_milliseconds"], n = this.from.key_code;
    if (this.singleTapEvent === void 0) {
      this.singleTapEvent = { key_code: n };
      const l = (f = this.manipulator.from.modifiers) == null ? void 0 : f.mandatory;
      l && (this.singleTapEvent.modifiers = l.filter(
        (_) => _ !== "any"
      ));
    }
    const r = ["double-tap", n];
    this.from.modifiers && [this.from.modifiers.mandatory, this.from.modifiers.optional].map((l) => l != null && l.length ? l.join(",") : "").forEach((l) => l && r.push(l));
    const s = r.join("-"), u = O(s).build(), a = O(s).unless().build(), d = {
      ...this.manipulator,
      conditions: [...this.manipulator.conditions || [], u]
    }, c = {
      ...this.manipulator,
      to: [p(s, 1)],
      conditions: [a],
      to_delayed_action: {
        to_if_invoked: [
          ...this.singleTapEvent ? [this.singleTapEvent] : [],
          p(s, 0)
        ],
        to_if_canceled: [p(s, 0)]
      }
    };
    return c.parameters = {
      "basic.to_delayed_action_delay_milliseconds": o
    }, [d, c];
  }
}
function vt() {
  return new Ye();
}
class Ye {
  constructor() {
    this.manipulator = {
      type: "mouse_motion_to_scroll"
    };
  }
  modifiers(e, i) {
    return this.manipulator.from = {
      modifiers: m(
        e,
        i
      )
    }, this;
  }
  condition(...e) {
    const { conditions: i = [] } = this.manipulator;
    return this.manipulator.conditions = [...i, ...e.map(M)], this;
  }
  options(e) {
    return this.manipulator.options = { ...this.manipulator.options, ...e }, this;
  }
  build(e) {
    return [{ ...this.manipulator }];
  }
}
function Ct(t, ...e) {
  return new N(t, ...e);
}
class N {
  constructor(e, ...i) {
    this.ruleDescription = e, this.manipulatorSources = [], this.allowEmptyManipulators = !1, this.conditions = i;
  }
  manipulators(e) {
    return Array.isArray(e) ? e.forEach((i) => this.manipulatorSources.push(i)) : this.manipulatorSources.push(e), this;
  }
  condition(...e) {
    return e.forEach((i) => this.conditions.push(i)), this;
  }
  description(e) {
    return this.ruleDescription = e, this;
  }
  build(e) {
    const i = {
      description: this.ruleDescription,
      manipulators: this.manipulatorSources.reduce(
        (n, r) => [...n, ...S(r, e)],
        []
      )
    };
    if (!this.allowEmptyManipulators && i.manipulators.length === 0)
      throw new Error(`"manipulators" is empty in "${i.description}"`);
    if (this.conditions.length === 0)
      return i;
    const o = this.conditions.map(M);
    return i.manipulators = i.manipulators.map(
      (n) => n.type === "basic" ? { ...n, conditions: [...n.conditions || [], ...o] } : { ...n }
    ), i;
  }
}
function Ze(t) {
  return typeof t.build == "function";
}
function et(t, e) {
  return Ze(t) ? t.build(e) : t;
}
const F = [
  ...P,
  ...B,
  ...H
];
function tt(t, e, i = 1, o = 0) {
  return new ot(t, e, i, o);
}
function it(t, e, i, o = 1, n = 0) {
  return tt(e, i, o, n).modifiers(t);
}
function Mt(t, e, i = 1, o = 0) {
  return it("Hyper", t, e, i, o);
}
class ot extends N {
  constructor(e, i, o = 1, n = 0) {
    const r = b(e).map(
      (s) => v(s, F, "as layer key")
    );
    i || (i = `layer-${r.join("-")}`), super(`Layer - ${i}`), this.onValue = o, this.offValue = n, this.replaceLayerKeyToIfAlone = !1, this.keys = r, this.varName = i, this.layerCondition = O(this.varName, this.onValue), this.condition(this.layerCondition), this.allowEmptyManipulators = !0;
  }
  modifiers(e, i) {
    return this.layerModifiers = e || i ? m(e, i) : void 0, this;
  }
  /** Config the layer key. */
  configKey(e, i = !1) {
    return this.layerKeyManipulator || (this.layerKeyManipulator = J("fn")), e(this.layerKeyManipulator), this.replaceLayerKeyToIfAlone = i, this;
  }
  build(e) {
    var n, r, s, u;
    const i = super.build(e), o = this.conditions.filter((a) => a !== this.layerCondition).map(M);
    ((r = (n = this.layerModifiers) == null ? void 0 : n.mandatory) != null && r.length || (u = (s = this.layerModifiers) == null ? void 0 : s.optional) != null && u.length) && i.manipulators.forEach((a) => this.addModifierAnyToManipulator(a));
    for (const a of this.keys)
      i.manipulators = [
        ...ne(
          a,
          this.varName,
          this.onValue,
          this.offValue,
          this.layerModifiers,
          o,
          e,
          this.layerKeyManipulator,
          this.replaceLayerKeyToIfAlone
        ),
        ...i.manipulators
      ];
    return i;
  }
  // If the layer has modifiers, set manipulator modifiers to { mandatory: ['any'] }
  addModifierAnyToManipulator(e) {
    if (e.type === "basic") {
      if (e.from.modifiers) {
        const { mandatory: i, optional: o } = e.from.modifiers;
        if (o != null && o.length || i != null && i.length && (i.length > 1 || i[0] !== "any"))
          throw new Error(
            "Layers with modifiers cannot have modifiers on manipulators"
          );
      }
      e.from.modifiers = { mandatory: ["any"] };
    }
  }
}
function ne(t, e, i, o, n, r, s, u, a) {
  function d(y) {
    var W;
    if (!u)
      return y;
    const E = u.build()[0], w = b(y)[0];
    if ([
      "to",
      "to_if_alone",
      "to_if_held_down",
      "to_after_key_up"
    ].forEach(
      (k) => {
        var V;
        return (V = E[k]) == null ? void 0 : V.forEach(
          (L) => w[k] = [...w[k] || [], L]
        );
      }
    ), E.to_delayed_action) {
      w.to_delayed_action = w.to_delayed_action || {
        to_if_invoked: [],
        to_if_canceled: []
      };
      for (const k of ["to_if_invoked", "to_if_canceled"])
        E.to_delayed_action[k].forEach(
          (V) => {
            var L;
            return (L = w.to_delayed_action) == null ? void 0 : L[k].push(V);
          }
        );
    }
    return a && (w.to_if_alone = (W = w.to_if_alone) == null ? void 0 : W.filter(
      (k) => !("key_code" in k && k.key_code === t)
    )), y;
  }
  const c = J({ key_code: t, modifiers: n }).toVar(e, i).toAfterKeyUp(p(e, o)).toIfAlone({ key_code: t });
  if (r != null && r.length && c.condition(...r), !s)
    return d(c.build());
  const f = [
    `layer_${t}`,
    ...n ? [JSON.stringify(n)] : [],
    ...(r || []).map((y) => JSON.stringify(y)).sort()
  ].join("_"), l = s.getCache(f);
  if (l != null && l.to && l.to_after_key_up)
    return l.to.find(
      (E) => "set_variable" in E && E.set_variable.name === e
    ) || (l.to.push(p(e, i)), l.to_after_key_up.push(p(e, o))), d(l), [];
  const _ = c.build(s);
  return s.setCache(f, _[0]), d(_);
}
const Y = {
  "simlayer.threshold_milliseconds": 200
};
function Et(t, e, i, o = 1, n = 0) {
  return new nt(t, e, i, o, n);
}
class nt extends N {
  constructor(e, i, o, n = 1, r = 0) {
    const s = b(e).map(
      (u) => v(u, F, "as simlayer key")
    );
    i || (i = `simlayer-${s.join("-")}`), super(`Simlayer - ${i}`), this.threshold = o, this.onValue = n, this.offValue = r, this.sharedLayerKeys = [], this.simultaneousOptions = {
      detect_key_down_uninterruptedly: !0,
      key_down_order: "strict",
      key_up_order: "strict_inverse",
      key_up_when: "any"
    }, this.layerModifiers = { optional: ["any"] }, this.keys = s, this.varName = i, this.layerCondition = O(this.varName, this.onValue), this.condition(this.layerCondition);
  }
  modifiers(e, i) {
    return this.layerModifiers = e || i ? m(e, i) : void 0, this;
  }
  /** Set simultaneous_options on the simlayer toggle manipulator */
  options(e) {
    return Object.assign(this.simultaneousOptions, e), this;
  }
  /** Enable layer with the same variable and manipulators with this simlayer */
  enableLayer(...e) {
    return e.map(
      (i) => v(i, F, "as layer key")
    ).forEach((i) => {
      if (this.keys.includes(i))
        throw new Error(`Key ${i} is already used in ${this.ruleDescription}`);
      if (this.sharedLayerKeys.includes(i))
        throw new Error(
          `Key ${i} is already used as shared layer key in  ${this.ruleDescription}`
        );
      this.sharedLayerKeys.push(i);
    }), this;
  }
  build(e) {
    const i = super.build(e), o = (e == null ? void 0 : e.getParameters(Y)) ?? Y, n = this.threshold || o["simlayer.threshold_milliseconds"], r = this.conditions.length > 1 ? this.conditions.filter((a) => a !== this.layerCondition).map(M) : void 0, s = p(this.varName, this.onValue), u = p(this.varName, this.offValue);
    i.manipulators.concat().forEach((a) => {
      var c;
      if (a.type !== "basic")
        throw new Error(
          `Unsupported manipulator type ${a.type} in simlayer ${this.ruleDescription}`
        );
      const d = (c = a.from) == null ? void 0 : c.key_code;
      if (!d)
        throw new Error(
          `Missing from.key_code in simlayer ${this.ruleDescription}`
        );
      this.layerModifiers && (a.from.modifiers = {
        ...a.from.modifiers,
        ...this.layerModifiers
      });
      for (const f of this.keys)
        i.manipulators.push({
          type: "basic",
          parameters: {
            "basic.simultaneous_threshold_milliseconds": n
          },
          to: [s, ...a.to || []],
          from: {
            simultaneous: [{ key_code: f }, { key_code: d }],
            simultaneous_options: {
              ...this.simultaneousOptions,
              to_after_key_up: [
                ...this.simultaneousOptions.to_after_key_up || [],
                u
              ]
            },
            modifiers: this.layerModifiers
          },
          conditions: r
        });
    });
    for (const a of this.sharedLayerKeys)
      i.manipulators = [
        ...ne(
          a,
          this.varName,
          this.onValue,
          this.offValue,
          this.layerModifiers,
          r,
          e
        ),
        ...i.manipulators
      ];
    return i;
  }
}
const Z = {
  "duo_layer.threshold_milliseconds": 200
};
function Tt(t, e, i, o = 1, n = 0) {
  return new rt(t, e, i, o, n);
}
class rt extends N {
  constructor(e, i, o, n = 1, r = 0) {
    o || (o = `duo-layer-${e}-${i}`), super(`Layer - ${o}`), this.key1 = e, this.key2 = i, this.onValue = n, this.offValue = r, this.simultaneousOptions = {}, this.varName = o, this.layerCondition = O(this.varName, this.onValue), this.condition(this.layerCondition), this.allowEmptyManipulators = !0;
  }
  threshold(e) {
    return this.simultaneousThreshold = e, this;
  }
  options(e) {
    return Object.assign(this.simultaneousOptions, e), this;
  }
  build(e) {
    var d, c, f, l;
    const i = super.build(e), o = (e == null ? void 0 : e.getParameters(Z)) ?? Z, n = this.simultaneousThreshold || o["duo_layer.threshold_milliseconds"], r = this.conditions.filter((_) => _ !== this.layerCondition).map(M), s = Ge(
      [this.key1, this.key2],
      {
        ...this.simultaneousOptions,
        to_after_key_up: [
          ...this.simultaneousOptions.to_after_key_up || [],
          p(this.varName, this.offValue)
        ]
      },
      n
    ).modifiers("??").to(p(this.varName, this.onValue));
    if (r.length && s.condition(...r), !e)
      return i.manipulators = [...s.build(), ...i.manipulators], i;
    const u = [
      `duo_layer_${this.key1}_${this.key2}`,
      ...r.map((_) => JSON.stringify(_)).sort()
    ].join("_"), a = e.getCache(u);
    if (a)
      ((d = a.to) == null ? void 0 : d.find(
        (y) => "set_variable" in y && y.set_variable.name === this.varName
      )) || ((c = a.to) == null || c.push(p(this.varName, this.onValue)), (l = (f = a.from.simultaneous_options) == null ? void 0 : f.to_after_key_up) == null || l.push(
        p(this.varName, this.offValue)
      ));
    else {
      const _ = s.build(e)[0];
      e.setCache(u, _), i.manipulators = [_, ...i.manipulators];
    }
    return i;
  }
}
class st {
  constructor() {
    this.parameters = {}, this.cache = /* @__PURE__ */ new Map();
  }
  setParameters(e) {
    Object.assign(this.parameters, e);
  }
  getParameters(e) {
    const i = { ...e };
    for (const o of Object.keys(e))
      o in this.parameters && this.parameters[o] !== void 0 && Object.assign(i, { [o]: this.parameters[o] });
    return i;
  }
  getCache(e) {
    return this.cache.get(e);
  }
  setCache(e, i) {
    this.cache.set(e, i);
  }
}
const at = {
  "basic.to_if_alone_timeout_milliseconds": 1e3,
  "basic.to_if_held_down_threshold_milliseconds": 500,
  "basic.to_delayed_action_delay_milliseconds": 500,
  "basic.simultaneous_threshold_milliseconds": 50,
  "mouse_motion_to_scroll.speed": 100
};
function lt(t, e = {}) {
  const {
    "double_tap.delay_milliseconds": i,
    "simlayer.threshold_milliseconds": o,
    ...n
  } = e, r = new st();
  r.setParameters({
    "double_tap.delay_milliseconds": i
  }), r.setParameters({
    "simlayer.threshold_milliseconds": o
  });
  const s = t.map((a) => et(a, r)), u = {
    rules: s.filter((a) => a.manipulators.length),
    parameters: {
      ...at,
      ...n
    }
  };
  if (u.rules.length === 0)
    throw new Error('complex_modifications "rules" is empty ');
  return u.rules.length < s.length && console.warn(`Rules with empty manipulators are ignored: 
${s.filter((a) => a.manipulators.length === 0).map((a) => "- " + a.description).join(`
`)}
`), u;
}
const D = {
  karabinerConfigDir() {
    return require("node:path").join(
      require("node:os").homedir(),
      ".config/karabiner"
    );
  },
  karabinerConfigFile() {
    return require("node:path").join(
      this.karabinerConfigDir(),
      "karabiner.json"
    );
  },
  readKarabinerConfig() {
    return require(this.karabinerConfigFile());
  },
  writeKarabinerConfig(t) {
    return require("node:fs/promises").writeFile(
      this.karabinerConfigFile(),
      t
    );
  },
  exit(t = 0) {
    process.exit(t);
  }
};
function Kt(t, e, i = {}) {
  const o = t === "--dry-run" ? { profiles: [{ name: t, complex_modifications: { rules: [] } }] } : D.readKarabinerConfig(), n = o == null ? void 0 : o.profiles.find((s) => s.name === t);
  n || I(`⚠️ Profile ${t} not found in ${D.karabinerConfigFile()}.

ℹ️ Please check the profile name in the Karabiner-Elements UI and 
    - Update the profile name at writeToProfile()
    - Create a new profile if needed
 `);
  try {
    n.complex_modifications = lt(e, i);
  } catch (s) {
    I(s);
  }
  const r = JSON.stringify(o, null, 2);
  if (t === "--dry-run") {
    console.info(r);
    return;
  }
  D.writeKarabinerConfig(r).catch(I), console.log(`✓ Profile ${t} updated.`);
}
function I(t) {
  return t && console.error(typeof t == "string" ? t : t.message || t), D.exit(1);
}
export {
  g as ConditionBuilder,
  M as buildCondition,
  lt as complexModifications,
  at as defaultComplexModificationsParameters,
  X as defaultDoubleTapParameters,
  Z as defaultDuoLayerParameters,
  Y as defaultSimlayerParameters,
  Tt as duoLayer,
  Mt as hyperLayer,
  ct as ifApp,
  dt as ifDevice,
  ft as ifDeviceExists,
  _t as ifEventChanged,
  pt as ifInputSource,
  ht as ifKeyboardType,
  O as ifVar,
  Ne as isConditionBuilder,
  tt as layer,
  J as map,
  mt as mapConsumerKey,
  wt as mapDoubleTap,
  yt as mapPointingButton,
  Ge as mapSimultaneous,
  it as modifierLayer,
  vt as mouseMotionToScroll,
  Ct as rule,
  Et as simlayer,
  U as to$,
  Ae as toApp,
  Le as toCgEventDoubleClick,
  Te as toConsumerKey,
  ve as toHyper,
  $e as toInputSource,
  h as toKey,
  Ce as toMeh,
  De as toMouseCursorPosition,
  Pe as toMouseKey,
  Ee as toNone,
  je as toNotificationMessage,
  Se as toPaste,
  Ke as toPointingButton,
  Oe as toRemoveNotificationMessage,
  p as toSetVar,
  Be as toSleepSystem,
  Ve as toStickyModifier,
  Me as toSuperHyper,
  xe as toTypeSequence,
  bt as withCondition,
  gt as withMapper,
  kt as withModifier,
  Kt as writeToProfile
};
